/* 
 * The MIT License
 * 
 * Copyright (c) 2007 University of Salzburg, www.uni-salzburg.at
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package at.uni_salzburg.cs.exotasks.scheduling.utils;

/**
 * @author Daniel Iercan (daniel.iercan@aut.upt.ro)
 *
 * This class represents a stack, built on top of a double linked list.
 */
public class DoubleLinkedStack extends DoubleLinkedList {

	public DoubleLinkedStack(int index) {
		super(index);
	}
	
	/**
	 * Push an element on to the stack
	 * @param element
	 */
	public void push(MultiLinkEelement element){
		add(element);
	}
	
	/**
	 * Pop an element out of the stack
	 * @return
	 */
	public MultiLinkEelement pop() throws IndexOutOfBoundsException{
		MultiLinkEelement element = getTail();
		if(element == null){
			throw new IndexOutOfBoundsException("There is no element in the stack.");
		}
		remove(element);
		return element;
	}
}
